#import "gikoController.h"

@implementation gikoController

- (NSString *) GikoPath
{
    NSMutableString *path = [[[NSMutableString alloc] initWithCapacity:1024] autorelease];		

    [path appendString:[[NSBundle mainBundle]bundlePath]];
    [path appendString:@"/Contents/Resources/gikoBASIC"];
    return path;
}

- (IBAction)gikoEnter:(id)sender
{

    if ( [ gikoTask isRunning ] )
    {
        NSMutableString *inputLine = [[[NSMutableString alloc] initWithCapacity:1024] autorelease];	
        
        [ inputLine appendString: [ gikoInput stringValue ] ];
        [ inputLine appendString: @"\n" ];
    
        [ self appendOutput: inputLine ];
        [ gikoTask sendInputString: inputLine ];
    }
    else
    {
        if ( gikoTask != nil ) [ gikoTask release ];
        gikoTask=[[TaskWrapper alloc] initWithController:self arguments:[NSArray arrayWithObjects:[self GikoPath],nil]];
        [gikoTask startProcess];
    }

}

- (void)appendOutput:(NSString *)output
{
    // add the string (a chunk of the results from locate) to the NSTextView's
    // backing store, in the form of an attributed string
    [[gikoOutput textStorage] appendAttributedString: [[[NSAttributedString alloc]
                             initWithString: output] autorelease]];
    // setup a selector to be called the next time through the event loop to scroll
    // the view to the just pasted text.  We don't want to scroll right now,
    // because of a bug in Mac OS X version 10.1 that causes scrolling in the context
    // of a text storage update to starve the app of events
    [self performSelector:@selector(scrollToVisible:) withObject:nil afterDelay:0.0];
}

// This routine is called after adding new results to the text view's backing store.
// We now need to scroll the NSScrollView in which the NSTextView sits to the part
// that we just added at the end
- (void)scrollToVisible:(id)ignore {
    [gikoOutput scrollRangeToVisible:NSMakeRange([[gikoOutput string] length], 0)];
}

- (void)processStarted
{
//    [ gikoOutput setString: @"" ];
    [ gikoEnterButton setTitle: NSLocalizedString(@"Enter",@"") ];
}

// A callback that gets called when a TaskWrapper is completed, allowing us to do any cleanup
// that is needed from the app side.  This method is implemented as a part of conforming
// to the ProcessController protocol.
- (void)processFinished
{
    [ gikoEnterButton setTitle: NSLocalizedString(@"Run",@"") ];
}

-(void)awakeFromNib
{
    [ gikoOutput setString: @"" ];
    gikoTask=[[TaskWrapper alloc] initWithController:self arguments:[NSArray arrayWithObjects:[self GikoPath],nil]];
    [gikoTask startProcess];
}

@end
